
(select-unregistered-module (scythe internal macro)
                            ()
                            ((scythe internal core public)
                             (scythe internal core private)
                             (scythe internal syntax)
                             (scythe internal identifier)
                             (scythe internal cmpl-env)))

(module-register (current-module) 'force)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Explicit Renaming

(define (er-macro-make-rename-proc def-env)
  (let ((memo '()))
    (lambda (x)
      (cond ((symbol? x)
             (let* ((m (assq x memo))
                    (i (if m (cdr m) (make-identifier x def-env))))
               (unless m
                 (set! memo (cons (cons x i) memo)))
               i))
            ((identifier? x)
             x)
            (else
             (error "macro: rename: invalid argument" x))))))

(define (er-macro-make-compare-proc use-env)
  (lambda (x y)
    (env-identifier=? use-env x y)))

(module-export (current-module) 'er-macro-transformer)
(define (er-macro-transformer expander)
  (lambda (form use-env def-env)
    (expander form
              (er-macro-make-rename-proc def-env)
              (er-macro-make-compare-proc use-env))))

