#include "file.c"

#include "test.h"

TEST_GROUP(file);

static ScmScythe *scy;
static ScmRefStackInfo rsi;

TEST_SETUP(file)
{
  scy = ut_scythe_setup(false);
  scm_ref_stack_save(&rsi);
}

TEST_TEAR_DOWN(file)
{
  scm_ref_stack_restore(&rsi);
  ut_scythe_tear_down(scy);
}

TEST(file, module_name_to_load_name)
{
  ScmObj name = SCM_OBJ_INIT, actual = SCM_OBJ_INIT, expected = SCM_OBJ_INIT;

  SCM_REFSTK_INIT_REG(&name, &actual, &expected);

  name = ut_read_cstr("(foo bar baz)");
  expected = ut_read_cstr("\"foo/bar/baz\"");
  actual = scm_module_name_to_load_name(name);

  TEST_ASSERT_SCM_EQUAL(expected, actual);
}
